
//+------------------------------------------------------------------+
//|                                                   EA_HP_DIFF.mq4 |
//|                                  Copyright  2013, Artem Kononov |
//|                                            artem_kononov@ukr.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Artem Kononov"
#property link      "artem_kononov@ukr.net"
extern string I                     = "===   ===";
extern int Slippage                 =       3;  //  
extern int filterINpercents=0; 
extern bool TMAfilt=true; 
extern bool SSRC_1=true;
extern bool SSRC_2=true;
extern double SSRC_1z=0.9;
extern double SSRC_2z=0.75;
extern int TakeProfit=0; 
extern int StopLoss=0; 
extern int Bezubitok=30;
extern int TralSTART=10;
extern int Tral=10;
extern bool Traling=true;
extern bool PAZBOPOTclose                 =   true;
extern bool zercalOtrazhen                 =   false;
extern double Lot                   =     0.1;  //  .  Lot = 0,    ,    
extern double LotPersDepo           =      10;  //  , ,    
extern bool BarTick                 =   false;  //    .  BarTick = true,      ,      . 
extern int OffSet                   =      10;  //      ,   (   0)
extern string TIMESTART             = "00:00";  //    
extern string TIMESTOP              = "23:59";  //    
extern double MAGICMA               =     123;  //   ()    
extern string wwII                    = "===   SSRC";
extern string Indicator = "0-CCI 1-RSI 2-WPR 3-MA" ;
extern int selectIndicator = 0;
//---- Snake 

extern int    SnakeRange   =3; 
extern int    FilterPeriod =21; 
extern double MartFiltr    =2;
extern string II                    = "===   ===";
 
extern string wII                    = "===   TMA";
extern string TimeFrame       = "current time frame";
extern int    HalfLength      = 56;
extern int    Price           = PRICE_CLOSE;
extern double ATRMultiplier   = 2.0;
extern int    ATRPeriod       = 100;
extern bool   Interpolate     = true;

extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsOnHighLow = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
double filter1,filter2,filter3;

bool bFlagNewBar,bCheackTime;
string sSig,strInfo[],sComment,sStr;
int iFlagTrade,iDigitLot,iTicket,iType,iShift,iShift_2,iFlag,pp;
double iBuy,iSell,dMain,dSignal,dMainPenult,dSignalPenult,dTakeProfit,dStopLoss,dPrice,dblInfo[],dBreakEven,dOffSet,dLotM,dTrail,SSRC1,SSRC2;
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
int init(){
//----
         dTakeProfit = TakeProfit;
         dStopLoss = StopLoss;
       
         dOffSet = OffSet;
       
         if(Digits==5 || Digits==3){
            dTakeProfit = dTakeProfit*10;
            dStopLoss = dStopLoss*10;
            dBreakEven = dBreakEven*10;
            dOffSet = dOffSet*10;
            dTrail = dTrail*10;
         }
         if(StopLoss > 0)Info.ChangeToDigitCheckStopLev(dStopLoss);
         else dStopLoss = 0;
         if(TakeProfit > 0)Info.ChangeToDigit(Symbol(),dTakeProfit);
         else dTakeProfit = 0;
         
         iDigitLot = Info.Get.LotDigit(Symbol());
         
         if(BarTick){
            iShift = 1;
            iShift_2 = 2;
         }else{ 
            iShift = 0; 
            iShift_2 = 1;
         }   
         
         if(dBreakEven > 0)iFlag = 1;
         else iFlag = 0;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit(){
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start(){  //33 - all, 0 - buy, 2 - sell
//----
pp=0;
if(TMAfilt==False){filterINpercents=-1000;}

if(Bezubitok!=0){
int k4=OrdersTotal();
  for (int i4=0; i4<k4; i4++) {
    if(OrderSelect(i4, SELECT_BY_POS, MODE_TRADES)) {
    
    if(OrderType()==OP_BUY){
    if(Bid-OrderOpenPrice()>Bezubitok*Point){   
      if(OrderStopLoss()<OrderOpenPrice()){ 
     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,CLR_NONE);
    }}}
    
     if(OrderType()==OP_SELL){
    if(OrderOpenPrice()-Ask>Bezubitok*Point){    
      if(OrderStopLoss()>OrderOpenPrice()||OrderStopLoss()==0){
     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,CLR_NONE);
    }}}
    
   }}}

if(Traling==True){

int k3=OrdersTotal();
  for (int i3=0; i3<k3; i3++) {
    if (OrderSelect(i3, SELECT_BY_POS, MODE_TRADES)) {
    
    if(OrderType()==OP_BUY){
    if(Bid-OrderOpenPrice()>TralSTART*Point){   
      if(OrderStopLoss()<Bid-Tral*Point){ 
     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Tral*Point,OrderTakeProfit(),0,CLR_NONE);
    }}}
    
     if(OrderType()==OP_SELL){
    if(OrderOpenPrice()-Ask>TralSTART*Point){    
      if(OrderStopLoss()>Ask+Tral*Point||OrderStopLoss()==0){
     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Tral*Point,OrderTakeProfit(),0,CLR_NONE);
    }}}
    
   }}
} 
             
            bFlagNewBar = Info.isNewBar(Symbol(),0,false);
         
            bCheackTime = Cheack();
            
            
            
              
                
                  if(bCheackTime==false)return;
SSRC1=iCustom(NULL,0,"SSRC",Indicator,selectIndicator,SnakeRange,FilterPeriod,MartFiltr,0,1);
SSRC2=iCustom(NULL,0,"SSRC",Indicator,selectIndicator,SnakeRange,FilterPeriod,MartFiltr,0,3);
  
      if(SSRC_1==True){if(SSRC1<SSRC_1z){if(SSRC2>SSRC_1z){pp=-1;}}}
       if(SSRC_2==True){ if(SSRC1<SSRC_2z){if(SSRC2>SSRC_2z){pp=-1;}}}
        if(SSRC_1==True){ if(SSRC1>-SSRC_1z){if(SSRC2<-SSRC_1z){pp=1;}}}
         if(SSRC_2==True){ if(SSRC1>-SSRC_2z){if(SSRC2<-SSRC_2z){pp=1;}}}
         
                 if(SSRC_1z<0||SSRC_2z<0){pp=-pp;}
 if(pp!=0){      
 if(pp==1){iType=1;dPrice = Ask;}
 if(pp==-1){iType=2;dPrice = Bid;}
filter1=iCustom(NULL,0,"TMA",TimeFrame,HalfLength,Price,ATRMultiplier,ATRPeriod,Interpolate,alertsOn,alertsOnCurrent,alertsOnHighLow,alertsMessage,alertsSound,alertsEmail,1,0);
filter2=iCustom(NULL,0,"TMA",TimeFrame,HalfLength,Price,ATRMultiplier,ATRPeriod,Interpolate,alertsOn,alertsOnCurrent,alertsOnHighLow,alertsMessage,alertsSound,alertsEmail,0,0);
filter3=iCustom(NULL,0,"TMA",TimeFrame,HalfLength,Price,ATRMultiplier,ATRPeriod,Interpolate,alertsOn,alertsOnCurrent,alertsOnHighLow,alertsMessage,alertsSound,alertsEmail,2,0);
  double filt1=(filter1-filter2)*filterINpercents/100+filter2;
double filt2=-(filter2-filter3)*filterINpercents/100+filter2;
if(zercalOtrazhen==false){
if(iType==1){if(filt2>Ask){if(bo()>0){return;}if(so()>0){if(PAZBOPOTclose==false){return;}if(PAZBOPOTclose==True){CloseO();}}Orders.Open(iType,NormalizeDouble(CalcLots(),iDigitLot),dPrice,Symbol(),"",dStopLoss,dTakeProfit,iDigitLot,Slippage,MAGICMA,iTicket,Red);pp=0;}}
if(iType==2){if(filt1<Bid){if(so()>0){return;}if(bo()>0)if(PAZBOPOTclose==false){return;}{if(PAZBOPOTclose==True){CloseO();}}Orders.Open(iType,NormalizeDouble(CalcLots(),iDigitLot),dPrice,Symbol(),"",dStopLoss,dTakeProfit,iDigitLot,Slippage,MAGICMA,iTicket,Red);pp=0;}}
                }
                
    if(zercalOtrazhen==true){
 if(iType==1){iType=2;if(filt1>Ask){if(so()>0){return;}if(bo()>0){if(PAZBOPOTclose==True){CloseO();}}Orders.Open(iType,NormalizeDouble(CalcLots(),iDigitLot),dPrice,Symbol(),"",dStopLoss,dTakeProfit,iDigitLot,Slippage,MAGICMA,iTicket,Red);}} 
if(iType==2){iType=1;if(filt2<Bid){if(bo()>0){return;}if(so()>0){if(PAZBOPOTclose==True){CloseO();}}Orders.Open(iType,NormalizeDouble(CalcLots(),iDigitLot),dPrice,Symbol(),"",dStopLoss,dTakeProfit,iDigitLot,Slippage,MAGICMA,iTicket,Red);}}
                }            
                
                
               }
               
            
            
         
           Comments();
            
//----
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
bool Cheack(){
         iFlagTrade = Info.isTimeSpanS(TimeCurrent(),TIMESTART,TIMESTOP);
         if(iFlagTrade==0)return(false);
         if(iFlagTrade==1)return(true);
         if(iFlagTrade==(-1)){Print("! iFlagTrade==(-1) TIMESTART = "+TIMESTART+" TIMESTOP = "+TIMESTOP);return(false);}
      return(true);
}
//+------------------------------------------------------------------+
//    
double CalcLots(){
      if(Lot > 0)return(Lot);
      else return(Info.Lot.PersentOfDeposit(Symbol(),LotPersDepo,iDigitLot,false,MAGICMA));
}
//+------------------------------------------------------------------+
void Comments(){
      
      iBuy = Orders.Get.Count(Symbol(), OP_BUY, MAGICMA, "", 0, 0);
      iSell = Orders.Get.Count(Symbol(), OP_SELL, MAGICMA, "", 0, 0);
      
      if(iBuy > 0){
         sStr = "BUY";
         dLotM = CalcLots();
      }   
      if(iSell > 0){
         sStr = "SELL";
         dLotM = CalcLots();
      }   
      if(iSell <= 0 && iBuy <= 0){
         sStr = "NOT";
         dLotM = 0;
      }   
      
      sComment = "       : "+AccountNumber() + "\n" +
                 "     : "+DoubleToStr(AccountBalance(),2)+ "\n" +
                 " : "+DoubleToStr(AccountEquity(),2) + "\n" +
                 "  : "+DoubleToStr(AccountProfit(),2) + "\n" +
                 "  : "+sStr            + "\n" +
                 "         : "+DoubleToStr(dLotM,iDigitLot);
                  
      Comment(sComment);            
}
//+------------------------------------------------------------------+
//              , 
//   : 1 -    >=  , 0 -     

//         
// _Symb       -      
// _dPersent   -   
// _iDigitLot  -  
// _isCalcRealPos -     (true - , false - ).       
// _imagic -       (-1,   ),   -1
//-//    
double Info.Lot.PersentOfDeposit(string _Symb, double _dPersent, int _iDigitLot, bool _isCalcRealPos, int _imagic = -1){ double dL = 0; double One_Lot = MarketInfo(_Symb,MODE_MARGINREQUIRED); double Balance = AccountBalance(); double dPriceP = 0; double dLossRes = 0; int iTypeOrder = 0; if(_isCalcRealPos){ for(int i=OrdersTotal()-1;i>=0;i--){ if(OrderSelect(i,SELECT_BY_POS)){ if((_imagic==-1 || OrderMagicNumber()==_imagic) && OrderStopLoss()!=0){ dPriceP = Info.Get.PriceOfPoint(OrderSymbol())*OrderLots(); iTypeOrder = OrderType(); if(iTypeOrder==OP_BUY || iTypeOrder==OP_BUYLIMIT || iTypeOrder==OP_BUYSTOP){ dLossRes += NormalizeDouble((OrderOpenPrice()-OrderStopLoss())*dPriceP,2); } } } } } Balance -= dLossRes; dL = NormalizeDouble(Balance*_dPersent/100/One_Lot,_iDigitLot); if(dL<MarketInfo(_Symb,MODE_MINLOT)){ Print(" ("+dL+")  ("+MarketInfo(_Symb,MODE_MINLOT)+").    ."); dL=MarketInfo(_Symb,MODE_MINLOT); } if(dL>MarketInfo(_Symb,MODE_MAXLOT)){ Print(" ("+dL+")  ("+MarketInfo(_Symb,MODE_MAXLOT)+").    ."); dL=MarketInfo(_Symb,MODE_MAXLOT); } return(dL); }
//+------------------------------------------------------------------+
//              1 
double Info.Get.PriceOfPoint(string B){RefreshRates();double S = 0; if(B!=""){S = MarketInfo(B,MODE_TICKVALUE)/(MarketInfo(B,MODE_TICKSIZE)/MarketInfo(B,MODE_POINT));}return(S);}
//+------------------------------------------------------------------+
//   true          
//  false     
//  _isCurNew == true,       ,  false -     
bool Info.isNewBar(string _symbol, int _tf, bool _isCurNew){ static datetime sTimeBar = 0; if(sTimeBar==0 && !_isCurNew) sTimeBar = iTime(Symbol(),_tf,0); if(sTimeBar==0 || sTimeBar!=iTime(Symbol(),_tf,0)){ sTimeBar=iTime(Symbol(),_tf,0); return(true); } return(false); }
//+------------------------------------------------------------------++
//   
// symbol -      
//--// -     0
int Info.Get.LotDigit(string symbol){ return(MathCeil(MathAbs(MathLog( MarketInfo(Symbol(), MODE_MINLOT) )/MathLog(10)))); }
//+------------------------------------------------------------------+
//   - 
// _symbol -  ("",  )
// _type   -   (-1,   )
//            :
//           99 -  
//           10 - Buy  Sell
//           50 -  (BuyStop, BuyLimit, SellStop, SellLimit)
//           51 - BuyStop  BuyLimit
//           52 - SellStop  SellLimit
//           53 - BuyStop  SellStop
//           54 - BuyLimit  SellLimit
// _magic  -     (-1,    )
// _comm   -       ("",   )
// minOpenTime -          (0 -  )
// maxOpenTime -          (0 -  )
//-//  -    0
int Orders.Get.Count(string _symbol, int _type, int _magic, string _comm, datetime minOpenTime, datetime maxOpenTime){ int iCount=0; if(OrdersTotal()<=0) return(0); for(int a1=OrdersTotal()-1;a1>=0;a1--){ if(OrderSelect(a1,SELECT_BY_POS)){ if((_symbol=="" || _symbol==OrderSymbol()) && (_magic==-1 || _magic==OrderMagicNumber()) && (_comm=="" || StringFind(OrderComment(),_comm)!=-1) &&  (minOpenTime==0 || OrderOpenTime()>=minOpenTime) && (maxOpenTime==0 || OrderOpenTime()<=maxOpenTime)){ if(_type==99){ iCount++; }else{ switch(OrderType()){ case OP_BUY: if(_type==OP_BUY || _type==10) iCount++; break; case OP_BUYSTOP: if(_type==OP_BUYSTOP || _type==50 || _type==51 || _type==53) iCount++; break; case OP_BUYLIMIT: if(_type==OP_BUYLIMIT || _type==50 || _type==51 || _type==54) iCount++; break; case OP_SELL: if(_type==OP_SELL || _type==10) iCount++; break; case OP_SELLSTOP: if(_type==OP_SELLSTOP || _type==50 || _type==52 || _type==53) iCount++; break; case OP_SELLLIMIT: if(_type==OP_SELLLIMIT || _type==50 || _type==52 || _type==54) iCount++; break; } } } } } return(iCount); }
//+------------------------------------------------------------------+
//          
// _start_time    -      hh:mm
// _end_time      -      hh:mm
//-// : 
//-// 1        
//-// 0   
//-// -1      
int Info.isTimeSpanS(datetime _time_check, string _start_time, string _end_time){ int res = -1; int _pos_del1 = StringFind(_start_time,":"); int _pos_del2 = StringFind(_end_time,":"); if(_start_time != "" && _end_time != "" && _pos_del1 >-1 && _pos_del2 >-1){ res = 0; int _st_hour = StrToInteger(StringSubstr(_start_time, 0, _pos_del1)); int _st_minute = StrToInteger(StringSubstr(_start_time, _pos_del2+1, 2)); int _ed_hour = StrToInteger(StringSubstr(_end_time, 0, _pos_del2)); int _ed_minute = StrToInteger(StringSubstr(_end_time, _pos_del2+1, 2)); res = Info.isTimeSpanI(_time_check, _st_hour, _st_minute, _ed_hour, _ed_minute); } return(res); }
//+------------------------------------------------------------------+
//         
// _start_hour    -   ,    0  23 
// _start_minute  -   ,    0  59 
// _end_hour      -   ,    0  23 
// _end_minute    -   ,    0  59 
//-// : 
//-// 1        
//-// 0   
//-// -1      
////--////  _end_hour+_end_minute   _start_hour+_start_minute   end   
int Info.isTimeSpanI(datetime _time_check, int _start_hour, int _start_minute, int _end_hour, int _end_minute){ int res = -1;if(_start_hour>=0 && _start_hour<24 && _start_minute>=0 && _start_minute<60 && _end_hour>=0 && _end_hour<24 && _end_minute>=0 && _end_minute<60){ res = 0; datetime _start_time = StrToTime(_start_hour+":"+_start_minute); datetime _end_time   = StrToTime(_end_hour+":"+_end_minute); if(_end_hour < _start_hour || (_end_hour == _start_hour && _end_minute < _start_minute)){ if(_time_check<=_end_time){ res = 1; }else{ if(_time_check>=_start_time){ res = 1; } } }else{ if(_time_check>=_start_time && _time_check<=_end_time) res = 1; } } return(res); }
//+------------------------------------------------------------------+
//       -   
// symbol -      
// v -    ,   
//--//   
void Info.ChangeToDigit(string symbol, double& v) { v *= MarketInfo(symbol,MODE_TICKSIZE); return; }
//+------------------------------------------------------------------+
//        -        
//     StopLevel,       StopLevel. 
//  StopLevel = 0,   Spread*2
// v -    
//-//   
void Info.ChangeToDigitCheckStopLev(double& v){ int iStopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL); if(iStopLevel==0) iStopLevel = MarketInfo(Symbol(),MODE_SPREAD)*2; if(v<iStopLevel) v = iStopLevel; v *= MarketInfo(Symbol(),MODE_TICKSIZE); }
//+------------------------------------------------------------------+
//   
// 1 - Buy, 2 - Sell, 3 - BuyStop, 4 - SellStop, 5 - BuyLimit, 6 - SellLimit
void Orders.Open(int type_order, double Lot, double price, string SymbolSend, string Comm, double SL, double TP, int dlot, int slip, int mag, int& tick, color clr=CLR_NONE)
{int l_error_64, l_error_130=0; double takeprofit, stoplosse;
switch(type_order){
  case 1 :
  if(type_order==1){
      while(true){
       if(IsTradeAllowed())
       {RefreshRates();       
       if(StopLoss!=0){double slpob=NormalizeDouble(MarketInfo(SymbolSend,MODE_ASK),MarketInfo(SymbolSend,MODE_DIGITS))-StopLoss*Point;}
       if(TakeProfit!=0){double tppob=NormalizeDouble(MarketInfo(SymbolSend,MODE_ASK),MarketInfo(SymbolSend,MODE_DIGITS))+TakeProfit*Point;}
        tick = OrderSend(SymbolSend,OP_BUY,NormalizeDouble(Lot,dlot),NormalizeDouble(MarketInfo(SymbolSend,MODE_ASK),MarketInfo(SymbolSend,MODE_DIGITS)),slip,slpob,tppob,Comm,mag,0,clr);
          if(tick==-1) { if(Error.Check(GetLastError(),l_error_130)) return; }else{ break; }
          continue;
      } }}
      
  case 2 :
   if(type_order==2){
      while(true){   
       if(IsTradeAllowed()){
          RefreshRates();
          if(StopLoss!=0){ slpob=NormalizeDouble(MarketInfo(SymbolSend,MODE_BID),MarketInfo(SymbolSend,MODE_DIGITS))+StopLoss*Point;}
           if(TakeProfit!=0){tppob=NormalizeDouble(MarketInfo(SymbolSend,MODE_BID),MarketInfo(SymbolSend,MODE_DIGITS))-TakeProfit*Point;}
        tick = OrderSend(SymbolSend,OP_SELL,NormalizeDouble(Lot,dlot),NormalizeDouble(MarketInfo(SymbolSend,MODE_BID),MarketInfo(SymbolSend,MODE_DIGITS)),slip,slpob,tppob,Comm,mag,0,clr);
          if(tick==-1) { if(Error.Check(GetLastError(),l_error_130)) return(-1); }else{ break; }
          continue;
      } }}
  
} }
//+------------------------------------------------------------------+
//   
//33 - all, 0 - buy, 2 - sell, 11 - buystop and buylimit, 21 - sellstop and selllimit, 
//31 - selllimit and buylimit, 41 - buystop and sellstop
//51 - buylimit and sellstop, 61 - selllimit and buystop
//_mag = -1 -    
//   
 
//+------------------------------------------------------------------+
//   
bool Error.Check(int l_error_64, int& error_130){   
   if(l_error_64==0) return(true);
   switch(l_error_64){
      case 4:  Print("  .  500 ...");       Sleep(500); return(false);
      case 6:  Print("   .  2 ...");         Sleep(2000);return(false);  
      case 8:  Print("  .  1 ...");       Sleep(1000);return(false);  
      case 129:Print("  .  500    ...");Sleep(500); return(false);
      case 135:Print(" .   ..");                      return(false);   
      case 136:Print(" .   ..");                   Sleep(1);   return(false);
      case 137:Print(" .  500 ...");                Sleep(500); return(false);
      case 138:Print(" . .");                                    return(false);
      case 141:Print("  .  1 ..");     Sleep(60000);return(false);
      case 146:Print("  .  ..");   Sleep(500); return(false);      
      case 130: if(error_130==0) {Print(" .   ...");Sleep(1000);error_130++;return(false); }else{ Print("   ."); return(true);}
      default: Print("   "+l_error_64);                        return(true);
   }         
   return(true);
}
//+------------------------------------------------------------------+




 int bo(){int count=0;
  for(int i=0;i<OrdersTotal();i++){
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){     
          if(OrderMagicNumber()==MAGICMA){
             if(OrderType()==OP_BUY){
            count++;
        }
      }
    }
  }
return(count);  
}




 int so(){int count=0;
  for(int i=0;i<OrdersTotal();i++){
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){     
          if(OrderMagicNumber()==MAGICMA){
             if(OrderType()==OP_SELL){
            count++;
        }
      }
    }
  }
return(count);  
}

 void CloseO()
{

int total = OrdersTotal();
for(int i=total-1;i>=0;i--)
{
OrderSelect(i, SELECT_BY_POS);
if(OrderMagicNumber()==MAGICMA){
int type = OrderType();
bool result = false;
switch(type)
{
//Close opened long positions
case OP_BUY : result = OrderClose( OrderTicket(), OrderLots(), NormalizeDouble(MarketInfo(OrderSymbol(), MODE_BID), Digits), 3, Red );
break;
//Close opened short positions
case OP_SELL : result = OrderClose( OrderTicket(), OrderLots(), NormalizeDouble(MarketInfo(OrderSymbol(), MODE_ASK), Digits), 3, Red );
break;
//Close pending orders
case OP_BUYLIMIT :
case OP_BUYSTOP :
case OP_SELLLIMIT :
case OP_SELLSTOP : result = OrderDelete( OrderTicket() );
}
if(result == false)
{
Print("Order " , OrderTicket() , " failed to close. Error:" , GetLastError() );
Sleep(3000);
}
}
}
}







